
bc_moveAttacher = {};

function bc_moveAttacher.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function bc_moveAttacher:load(xmlFile)

	self.moveableAttacher = {};
	self.moveableAttacher.index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.moveableAttacher#index"));
	self.moveableAttacher.max = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.moveableAttacher#maxY"), 0); 
	self.moveableAttacher.min = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.moveableAttacher#minY"), 0); 
	
	self.moveableAttacherUP = {};
	self.moveableAttacherUP.index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.attacherJoints.attacherJoint.topArm#rotationNode2"));
	self.moveableAttacherUP.max = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attacherJoints.attacherJoint.topArm#maxZ"), 0); 
	self.moveableAttacherUP.min = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attacherJoints.attacherJoint.topArm#minZ"), 0);
end;

function bc_moveAttacher:delete()
end;

function bc_moveAttacher:mouseEvent(posX, posY, isDown, isUp, button)
end;

function bc_moveAttacher:keyEvent(unicode, sym, modifier, isDown)

end;

function bc_moveAttacher:update(dt)

	if self.moveableAttacher ~= nil then
		local xAttacher, yAttacher, zAttacher = getTranslation(self.moveableAttacher.index);
		local maxY = self.moveableAttacher.max;
		local minY = self.moveableAttacher.min;
		local moveSpeed = 0.004;
			if InputBinding.isPressed(InputBinding.bc_ATTACHER_UP) then
				if yAttacher < maxY then
					yAttacher = yAttacher + moveSpeed;
				else
					yAttacher = maxY;
				end;
			elseif InputBinding.isPressed(InputBinding.bc_ATTACHER_DOWN) then
				if yAttacher > minY then
					yAttacher = yAttacher - moveSpeed;
				else
					yAttacher = minY;
				end;
			end;
		setTranslation(self.moveableAttacher.index, xAttacher, yAttacher, zAttacher);
	end;
		
	if self.moveableAttacherUP ~= nil then
		local xAttacher, yAttacher, zAttacher = getTranslation(self.moveableAttacherUP.index);
		local maxZ = self.moveableAttacherUP.max;
		local minZ = self.moveableAttacherUP.min;
		local moveSpeed = 0.004;
			if InputBinding.isPressed(InputBinding.bc_ATTACHER_UPUP) then
				if zAttacher < maxZ then
					zAttacher = zAttacher + moveSpeed;
				else
					zAttacher = maxZ;
				end;
			elseif InputBinding.isPressed(InputBinding.bc_ATTACHER_DOWNUP) then
				if zAttacher > minZ then
					zAttacher = zAttacher - moveSpeed;
				else
					zAttacher = minZ;
				end;
			end;
		setTranslation(self.moveableAttacherUP.index, xAttacher, yAttacher, zAttacher);
	end;		
end;

function bc_moveAttacher:onLeave()

end;

function bc_moveAttacher:draw()

end;

function bc_moveAttacher:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

